/***************************************************************************
 *            data.c
 *
 *  Thu Mar 31 19:40:29 2005
 *  Copyright  2005  DBW
 *  opraus@yahoo.com
  ****************************************************************************/
/* TODO (#1#): write asserts for data structures */
#include "defs.h"
#include <stdio.h>
int             board[256] = {
	OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB,
	OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB,
	OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB,
	OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB,
	BR, BN, BB, BQ, BK, BB, BN, BR, OB, OB, OB, OB, OB, OB, OB, OB,
	BP, BP, BP, BP, BP, BP, BP, BP, OB, OB, OB, OB, OB, OB, OB, OB,
	MT, MT, MT, MT, MT, MT, MT, MT, OB, OB, OB, OB, OB, OB, OB, OB,
	MT, MT, MT, MT, MT, MT, MT, MT, OB, OB, OB, OB, OB, OB, OB, OB,
	MT, MT, MT, MT, MT, MT, MT, MT, OB, OB, OB, OB, OB, OB, OB, OB,
	MT, MT, MT, MT, MT, MT, MT, MT, OB, OB, OB, OB, OB, OB, OB, OB,
	WP, WP, WP, WP, WP, WP, WP, WP, OB, OB, OB, OB, OB, OB, OB, OB,
	WR, WN, WB, WQ, WK, WB, WN, WR, OB, OB, OB, OB, OB, OB, OB, OB,
	OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB,
	OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB,
	OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB,
	OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB, OB,
};
int             indx[192];
int             pieces[2][16];
FILE           *debuglog;
FILE           *trace;
FILE           *blunders;
int             castle = 15;
int             epsquare = 0;
int             ext_pawn, ext_check, ext_1rep, ext_threat, ext_etd, ext_end,
                ext_recap, ext_real;
int             fails;
int             fhn, fh1;
int             fifty = 0;
int             followpv;
int             force[2];
int             types[16];
int             idepth;
int             killer0[MAXPLY] = {0};
int             killer1[MAXPLY] = {0};
int             killer2[MAXPLY] = {0};
int             pvl[MAXPLY];
int             kingsq[2] = {E1, E8};
int             misses;
int             nodes;
int             marker;
int             ply = 1;
int             probes;
int             used;
int             qnodes;
int             evals;
int             red_nohist;
int             red_razor;
int             red_futile;
int             red_xfutile;
int             red_delta;
int             red_null_fh;
int             researches;
int             sdepth;
int             qdepth;
int             shallow;
int             stm = 1;
int             stop_search;
int             victim;
int             victii;
float           bf = 2.0f;
int             scores[16];
int             strategy[16];
int             console;
int             rootalpha;
int             rootbeta;
int             rootphase;
int             ehashsize = EHASHSIZE;
sEHASHENTRY    *ehashtable;
int             hashsize = HASHSIZE;
sHASHENTRY     *hashtable;
sHISTDATA       move_history[512];
sHISTDATA      *mhs = move_history;
sMOVES         *last_move[MAXPLY];
sMOVES          move_list[4096];
UI64            key;
UI64            st;
UI64            zobrist[nbPieces][192];
UI64            mpr[16][8][2];
uMOVE           nomove[1];
uMOVE           pv[MAXPLY][MAXPLY];
unsigned int    history[2][64 * 64];
char            ms[128];
int             mb_best;
const int       pval[16] = {
	0, 0, 100, 100, 30, 30, 5000, 5000, 0, 0,
	30, 30, 50, 50, 100, 100
};
const int       mval[16] = {
	0, 0, 100, 100, 325, 325, MATE << 1, MATE << 1, 0, 0,
	325, 325, 500, 500, 975, 975
};
const int       nval[16] = {
	0, 0, 100, 100, 300, 300, 5000, 5000, 0, 0,
	325, 325, 500, 500, 975, 975
};
const int       cval[16] = {
	0, 0, 0, 0, 25, 25, 125, 125, 0, 0,
	50, 50, 75, 75, 100, 100
};
const int       fval[16] = {
	0, 0, 0, 0, 3, 3, 0, 0, 0, 0,
	3, 3, 5, 5, 12, 12
};
const int       dlta[16] = {
	-33, -31, -14, 18, 33, 31, 14, -18,	/* 0 - 7    Knight */
	-17, -15, 17, 15,	/* 8 - 11   Diagonal */
	-16, 1, 16, -1		/* 12 - 15  Lateral */
};
const int       wsquares[32] = {
	A1, C1, E1, G1,
	B2, D2, F2, H2,
	A3, C3, E3, G3,
	B4, D4, F4, H4,
	A5, C5, E5, G5,
	B6, D6, F6, H6,
	A7, C7, E7, G7,
	B8, D8, F8, H8
};
const int       bsquares[32] = {
	B1, D1, F1, H1,
	A2, C2, E2, G2,
	B3, D3, F3, H3,
	A4, C4, E4, G4,
	B5, D5, F5, H5,
	A6, C6, E6, G6,
	B7, D7, F7, H7,
	A8, C8, E8, G8
};
const int       rank7[192] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};
const int       middle[192] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};
const int       sq_color[192] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0
};
const int       rank67[2][192] = {
	{
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	}
};
const int       border[192] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	2, 1, 1, 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
	2, 1, 1, 1, 1, 1, 1, 2, 0, 0, 0, 0, 0, 0, 0, 0
};
const int       corner[2][192] = {
	{
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		2, 1, 0, 0, 0, 0, 1, 2, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0,
		2, 1, 0, 0, 0, 0, 1, 2, 0, 0, 0, 0, 0, 0, 0, 0
	}
};
int             distance[256];	/* radial distance */
int             taxicab[256];	/* sum of dx & dy */
int             manhattan[256];	/* min of x & y */
int             diagonalm[256];	/* distance off diagonal */
int             proximat[256];	/* radial score eg., 4, 4, 2, 1, 0, 0 */
int             pseudoev[256];	/* any square which could attack king given
				 * QRBorNP */
KINGDANGER      wks, bks;
int             ppfile[2][8];
int             mrank78[2];
const int       mobscale[32] = {
	-16, -8, 0, 6, 9, 12, 15, 17, 19, 20, 21, 22,
	23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, MF, 38, 39, 40, 41, 42
};
/*
 *
 A 'bare' passed pawn can range from worthless on the 7th
 to invaluable
 * on the 2nd, so mere rank is of little worth.
 if support >= defense, AND
 * mobile ...
 Distance leaves room for solutions Being passed is the largest
 * hurdle Rank is the length of the journey [through the obstacles] BASE - r *
 * enemy_terr * enemy_forces + (7-r) * distance_to_convert
 */
const int       passed_pawn[8] = {
	0, 5, 8, 15, 25, 43, 56, 0
};
/*
 *
 connected score counted 1x for each pawn. AND x2 in end
 crafty arasan
 * , 0, 0, 12, 24, 48, 100, 0
 0,10,11, 13, 31, 58, 117, 0
 0, 5, 5, 12, 28,
 * 53,  59, 0
 0, 5, 5,  7, 17, 32,  35, 0
 * pawns on the 6th rank beat a rook' - W.JORDAN MELBOURNE 1997
 Q. If search
 * found a way to win bishop in exchange for passer, would it?
 NB Pawn and
 * Kings counted twice.
 NB connected (escorted by pawn) is counred again in
 * escorted
 */
const int       connected_passer[8] = {
	0, 0, 1, 2, 10, 20, 40, 0
};
const int       blocked_passer[8] = {
	0, 3, 6, 9, 15, 21, 21, 0
	/* 0,  6,  9, 15, 25,  30,  30, 0   average values of crafty, arasan */
};
const int       candidate_passer[8] = {
	0, 1, 3, 5, 10, 15, 0, 0/* fruit uses 5 to 55 but has better
				 * 'definition' */
};
const int       supported_passer[8] = {
	0, 1, 1, 3, 9, 18, 36, 0
};
const int       escorted_passer[8] = {
	0, 0, 0, 2, 6, 12, 24, 0
};
 /* const */ int isolated_pst[2][192];
 /* const */ int k_to_war[2][192];
const int       holes[2][8] = {
	{C3, D3, E3, F3, C4, D4, E4, F4},
	{C6, D6, E6, F6, C5, D5, E5, F5}
};
const int       outposts[2][192] = {
	{
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 4, 6, 6, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 12, 15, 15, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 12, 18, 18, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 6, 12, 12, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 6, 12, 12, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 12, 18, 18, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 12, 15, 15, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 4, 6, 6, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	}
};
/*
 *
 const int btrap[192] = {
 0,0,0,0,0,0,0,0   ,0,0,0,0,0,0,0,0,
 * 0,0,0   ,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0   ,0,0,0,0,0,0,0,0,
 * ,0,0   ,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0   ,0,0,0,0,0,0,0,0,
 * ,0,G3   ,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0   ,0,0,0,0,0,0,0,0,
 * ,0,0   ,0,0,0,0,0,0,0,0,
 0,0,0,0,0,0,0,0   ,0,0,0,0,0,0,0,0,
 * 0,0   ,0,0,0,0,0,0,0,0,
 B6,0,0,0,0,0,0,G6   ,0,0,0,0,0,0,0,0,
 * ,0,0   ,0,0,0,0,0,0,0,0
 };
 */
const int       btrap[192] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	B3, 0, 0, 0, 0, 0, 0, G3, 0, 0, 0, 0, 0, 0, 0, 0,
	B4, 0, 0, 0, 0, 0, 0, G4, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	B5, 0, 0, 0, 0, 0, 0, G5, 0, 0, 0, 0, 0, 0, 0, 0,
	B6, 0, 0, 0, 0, 0, 0, G6, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};
const int       ntrap[192] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	A2, 0, 0, 0, 0, 0, 0, H2, 0, 0, 0, 0, 0, 0, 0, 0,
	B2, 0, 0, 0, 0, 0, 0, G2, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	B7, 0, 0, 0, 0, 0, 0, G7, 0, 0, 0, 0, 0, 0, 0, 0,
	A7, 0, 0, 0, 0, 0, 0, H7, 0, 0, 0, 0, 0, 0, 0, 0
};
const int       rtrap[2][192] = {
	{
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 0, 0, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 0, 0, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 0, 0, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 0, 0, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 0, 0, 0, 0, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	},
	{
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 0, 0, 0, 0, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 0, 0, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 0, 0, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 0, 0, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0,
		1, 1, 1, 0, 0, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0
	}
};
const int       wk_defect[192] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 0, 0, 0, 0,
	40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 0, 0, 0, 0,
	40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 0, 0, 0, 0,
	40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 0, 0, 0, 0,
	40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 0, 0, 0, 0,
	24, 32, 36, 40, 40, 36, 32, 24, 0, 0, 0, 0, 0, 0, 0, 0,
	18, 24, 32, 36, 36, 32, 24, 18, 0, 0, 0, 0, 0, 0, 0, 0,
	6, 0, 12, 24, 24, 12, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0
};
const int       bk_defect[192] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	6, 0, 12, 24, 24, 12, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0,
	18, 24, 32, 36, 36, 32, 24, 18, 0, 0, 0, 0, 0, 0, 0, 0,
	24, 32, 36, 40, 40, 36, 32, 24, 0, 0, 0, 0, 0, 0, 0, 0,
	40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 0, 0, 0, 0,
	40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 0, 0, 0, 0,
	40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 0, 0, 0, 0,
	40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 0, 0, 0, 0,
	40, 40, 40, 40, 40, 40, 40, 40, 0, 0, 0, 0, 0, 0, 0, 0
};
const int       p_curve[64] = {
	/*
	 * 0   1   2   3*  4  5#   6*  7  8#  9* 10* 11* 12* 13* 14* 15* 16
	 * 17  18  19
 m       R   2m     Rm  3m 2R R2m   Q 2Rm  R3m  3R 2R2m
	 * R4m Qm 2R3M
	 * ------------------------------
	 */
	MF, MF, MF, 31, 31, 29, 28, 28, 27, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 17,
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,
	/*---------------------------------------------------------------------------------
	    QR Q2m 2R4mQRm Q3m Q2RQR2m -2R -3m -Rm     -2m  -R      -m
	     17  16 15* 14* 13* 12* 11* 10*  9*  8*  7   6*  5*   4   3*  2   1   0			*/
	17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17,
	17, 17, 17, 17
};
const int       f_curve[128] = {
	/*
	 * 0   1   2   3*  4  5#   6*  7  8#  9*  10* 11* 12* 13* 14* 15* 16
	 * 17  18  19
 m       R   2m     Rm  3m  2R  R2m  Q  2Rm R3m 3R 2R2m
	 * R4m Qm 2R3M
	 * ----------------------------
	 */
	0, 0, 0, 0, 0, 2, 2, 2, 3, 3, 4, 5, 7, 8, 9, 11, 13, 15, 17, 19,
	21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 31, 32, 33, 33, MF, MF, MF, MF, MF,
	/*---------------------------------------------------------------------------------
	     17  16 15* 14* 13* 12* 11* 10*  9*  8*  7   6*  5*   4   3*  2   1   0			*/
	MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF,
	MF, MF, MF, MF,
	MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF,
	MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF,
	MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF,
	MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF, MF
};
int             vectors[273] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	17, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 15, 0,
	0, 17, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 15, 0, 0,
	0, 0, 17, 0, 0, 0, 0, 16, 0, 0, 0, 0, 15, 0, 0, 0,
	0, 0, 0, 17, 0, 0, 0, 16, 0, 0, 0, 15, 0, 0, 0, 0,
	0, 0, 0, 0, 17, 0, 0, 16, 0, 0, 15, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 17, 0, 16, 0, 15, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 17, 16, 15, 0, 0, 0, 0, 0, 0, 0,
	1, 1, 1, 1, 1, 1, 1, 0, -1, -1, -1, -1, -1, -1, -1, 0,
	0, 0, 0, 0, 0, 0, -15, -16, -17, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, -15, 0, -16, 0, -17, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, -15, 0, 0, -16, 0, 0, -17, 0, 0, 0, 0, 0,
	0, 0, 0, -15, 0, 0, 0, -16, 0, 0, 0, -17, 0, 0, 0, 0,
	0, 0, -15, 0, 0, 0, 0, -16, 0, 0, 0, 0, -17, 0, 0, 0,
	0, -15, 0, 0, 0, 0, 0, -16, 0, 0, 0, 0, 0, -17, 0, 0,
	-15, 0, 0, 0, 0, 0, 0, -16, 0, 0, 0, 0, 0, 0, -17, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};
 /* const */ char pst[16][192];
